/*
 * DiceGamePlayerTest.cpp
 */

#include "DiceGamePlayerTest.h"
#include "dicegame/DiceGamePlayer.h"
#include <cppunit/TestSuite.h>
#include <cppunit/TestCaller.h>

USING_NAMESPACE_CPPUNIT

void DiceGamePlayerTest::testCreate()
{
	DiceGamePlayer player;
	TEST_ASSERT_EQUALS("", player.getName().c_str());
	TEST_ASSERT_EQUALS(0, player.getWins());
	TEST_ASSERT_EQUALS(0, player.getLosses());
	DiceGamePlayer player2("Foo");
	TEST_ASSERT_EQUALS("Foo", player2.getName().c_str());
	TEST_ASSERT_EQUALS(0, player2.getWins());
	TEST_ASSERT_EQUALS(0, player2.getLosses());
}

void DiceGamePlayerTest::testWinGame()
{
	DiceGamePlayer player;
	TEST_ASSERT_EQUALS(0, player.getWins());
	player.winGame();
	TEST_ASSERT_EQUALS(1, player.getWins());
	player.winGame();
	TEST_ASSERT_EQUALS(2, player.getWins());
}

void DiceGamePlayerTest::testLoseGame()
{
	DiceGamePlayer player;
	TEST_ASSERT_EQUALS(0, player.getLosses());
	player.loseGame();
	TEST_ASSERT_EQUALS(1, player.getLosses());
	player.loseGame();
	TEST_ASSERT_EQUALS(2, player.getLosses());
}

Test* DiceGamePlayerTest::suite()
{
	TestSuite* suite = new TestSuite("DiceGamePlayerTest");
	suite->addTest(new TEST_CALLER(DiceGamePlayerTest, testCreate));
	suite->addTest(new TEST_CALLER(DiceGamePlayerTest, testWinGame));
	suite->addTest(new TEST_CALLER(DiceGamePlayerTest, testLoseGame));
	return suite;
}
